# DBIWrapper::Time::Now::Duration.pm
# Created by Drew Lesueur, 2015-08-18.
# Ported to DBIWrapper by James Pattie, 2016-08-22.
#
# Copyright (c) 2015-2016, GPSInsight, LLC  <http://www.gpsinsight.com/>
# All rights reserved.  This program is free software; you can redistribute it
# and/or modify it under the same terms as Perl itself.

package DBIWrapper::Time::Now::Duration;
use strict;

use vars qw($AUTOLOAD @ISA @EXPORT @EXPORT_OK);

require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw();

sub new {
  my $that = shift;
  my $seconds = shift;
  my $microseconds = shift;

  my $class = ref($that) || $that;
  my $self = bless {}, $class;

  $self->{seconds} = $seconds;
  $self->{microseconds} = $microseconds;
  
  return $self;
}

sub seconds {
  my $self = shift;
  return $self->{seconds};
}

sub nanoseconds {
  my $self = shift;
  
  if (! exists $self->{nanoseconds_cache})
  {
    $self->{nanoseconds_cache} = $self->{microseconds} * 1000;
  }
  
  return $self->{nanoseconds_cache};
}

1;
